/* $Id: x11defs.h,v 1.2 2010/02/17 15:05:02 kiesling Exp $ -*-c-*-*/

/*
  This file is part of Ctalk.
  Copyright  2005-2010  Robert Kiesling, ctalk@ctalklang.org.
  Permission is granted to copy this software provided that this copyright
  notice is included in all source code modules.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, 
  Inc., 51 Franklin St., Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef _X11DEFS_H

#if defined(__sparc__) && defined(__svr4__)
#define GRAPHICS_WRITE_SEND_EVENT 1 
#endif

#define SHM_REQ 0x00
#define SHM_DRAWABLE 0x01
#define SHM_GC 0x20
#define SHM_DATA 0x40
#define SHM_RETVAL 0x7f
#define SHM_SHUTDOWN 0xfe
#define make_req(s,r,w,g,d) do {(s)[SHM_REQ] = (r);	\
  strcpy (&((s)[SHM_DRAWABLE]), w); \
  strcpy (&((s)[SHM_GC]), g); \
  strcpy (&((s)[SHM_DATA]), d); } while (0);
#define wait_req(s) do { usleep (1000); } while ((s)[SHM_REQ]) 

#define DEFAULT_GCV_MASK (GCFunction | GCFillStyle | GCForeground | \
			  GCBackground | GCFont)
#define PANE_PUT_STR_REQUEST   1
#define PANE_WM_TITLE_REQUEST  2
#define PANE_CLEAR_WINDOW_REQUEST 3
#define PANE_CLEAR_RECTANGLE_REQUEST 4
#define PANE_DRAW_POINT_REQUEST 5
#define PANE_DRAW_LINE_REQUEST 6
#define PANE_DRAW_RECTANGLE_REQUEST 7
#define PANE_RESIZE_REQUEST 8
#define PANE_MOVE_REQUEST 9
#define PANE_REFRESH_REQUEST 10

#define WM_CONFIGURE_EVENTS (ExposureMask|StructureNotifyMask|PropertyChangeMask|SubstructureNotifyMask)
#define WM_INPUT_EVENTS (KeyPressMask|KeyReleaseMask|ButtonPressMask|ButtonReleaseMask)
#define KBDCHAR          (1 << 0)
#define KBDCUR           (1 << 1)
#define WINDELETE        (1 << 2)
#define BUTTONPRESS      (1 << 3)
#define BUTTONRELEASE    (1 << 4)
#define KEYPRESS         (1 << 5)
#define KEYRELEASE       (1 << 6)
#define MOTIONNOTIFY     (1 << 7)
#define EXPOSE           (1 << 8)
#define MAPNOTIFY        (1 << 12)
#define CONFIGURENOTIFY  (1 << 15)
#define MOVENOTIFY       (1 << 16)
#define RESIZENOTIFY     (1 << 17)
/***/
/* To be added. */
/*  #define DESTROYNOTIFY    (1 << 9) */
/*  #define VISIBILITYCHANGE (1 << 10) */
/*  #define STRUCTURENOTIFY  (1 << 11) */
/*  #define MAPREQUEST       (1 << 13) */
/*  #define CONFIGUREREQUEST (1 << 14) */

#define IS_XK_MODIFIER(k) (((k) == XK_Shift_L) || \
 ((k) == XK_Shift_R) || ((k) == XK_Control_L) || \
   ((k) == XK_Control_R) || ((k) == XK_Caps_Lock) || \
    ((k) == XK_Shift_Lock) || ((k) == XK_Meta_L) || \
    ((k) == XK_Meta_R) || ((k) == XK_Alt_L) || \
    ((k) == XK_Alt_R) || ((k) == XK_Super_L) || \
    ((k) == XK_Super_R) || ((k) == XK_Hyper_L) || \
    ((k) == XK_Hyper_R))

#endif /* _X11DEFS_H */
